library angular2.src.core.annotations.annotations;

import 'package:angular2/src/facade/lang.dart'
    show ABSTRACT, CONST, normalizeBlank, isPresent;
import 'package:angular2/src/facade/collection.dart' show ListWrapper, List;

@ABSTRACT()
class Directive {
  final dynamic selector;
  final dynamic bind;
  final dynamic implementsTypes;
  final dynamic lifecycle;
  final dynamic events;
  @CONST()
  const Directive({selector, bind, events, implementsTypes, lifecycle})
      : selector = selector,
        implementsTypes = implementsTypes,
        bind = bind,
        events = events,
        lifecycle = lifecycle;
  bool hasLifecycleHook(String hook) {
    return isPresent(this.lifecycle)
        ? ListWrapper.contains(this.lifecycle, hook)
        : false;
  }
}
class Component extends Directive {
  final dynamic services;
  @CONST()
  const Component(
      {selector, bind, events, services, implementsTypes, lifecycle})
      : services = services,
        super(
            selector: selector,
            bind: bind,
            events: events,
            implementsTypes: implementsTypes,
            lifecycle: lifecycle);
}
class Decorator extends Directive {
  final bool compileChildren;
  @CONST()
  const Decorator({selector, bind, events, implementsTypes, lifecycle,
      compileChildren: true})
      : compileChildren = compileChildren,
        super(
            selector: selector,
            bind: bind,
            events: events,
            implementsTypes: implementsTypes,
            lifecycle: lifecycle);
}
class Viewport extends Directive {
  @CONST()
  const Viewport({selector, bind, events, implementsTypes, lifecycle}) : super(
          selector: selector,
          bind: bind,
          events: events,
          implementsTypes: implementsTypes,
          lifecycle: lifecycle);
}
const onDestroy = "onDestroy";
const onChange = "onChange";
