library angular2.src.core.exception_handler;

import 'package:angular2/src/facade/lang.dart' show isPresent, print;
import 'package:angular2/src/facade/collection.dart'
    show ListWrapper, isListLikeIterable;

class ExceptionHandler {
  call(error, [stackTrace = null, reason = null]) {
    var longStackTrace = isListLikeIterable(stackTrace)
        ? ListWrapper.join(stackTrace, "\n\n")
        : stackTrace;
    var reasonStr = isPresent(reason) ? '''\n${reason}''' : '';
    print('''${error}${reasonStr}\nSTACKTRACE:\n${longStackTrace}''');
  }
}
